/*
 * Test code to determine error/relationship between Systick and BSL
 *
 */
#include <stdio.h>

#include <ti/devices/msp432p4xx/driverlib/driverlib.h>

#define    SYSTICK_TIMEOUT  20

uint16_t tickCounter;

void SysTick_Handler(void)
{
    MAP_WDT_A_clearTimer();
    MAP_GPIO_toggleOutputOnPin(GPIO_PORT_P1, GPIO_PIN0);
    tickCounter++;
}

int main(void)
{
    volatile uint32_t ii;

    /* Halting the Watchdog */
    MAP_WDT_A_holdTimer();
    tickCounter = 0;

  //  MSP432_Clock_init();

    if((P1->IN & BIT0)==1)
    {
        MAP_Interrupt_disableMaster();
        NVIC->ICER[0] = 0xFFFF;
        NVIC->ICPR[0] = 0xFFFF;
        NVIC->ICER[1] = 0xFFFF;
        NVIC->ICPR[1] = 0xFFFF;
        BSL_INVOKE(0xFC48FFFF);//BSL_CONFIG_INTERFACE_UART);<----------------------------------This works
    }

    GPIO_setAsInputPinWithPullDownResistor(GPIO_PORT_P4, GPIO_PIN4);//Configuration
    GPIO_setAsInputPinWithPullDownResistor(GPIO_PORT_P4, GPIO_PIN5);//Configuration
    GPIO_setAsInputPinWithPullDownResistor(GPIO_PORT_P4, GPIO_PIN6);//Configuration
    GPIO_setAsInputPinWithPullDownResistor(GPIO_PORT_P4, GPIO_PIN7);//Configuration

    if(GPIO_getInputPinValue(GPIO_PORT_P4, GPIO_PIN4) == GPIO_INPUT_PIN_HIGH &&
       GPIO_getInputPinValue(GPIO_PORT_P4, GPIO_PIN4) == GPIO_INPUT_PIN_HIGH &&
       GPIO_getInputPinValue(GPIO_PORT_P4, GPIO_PIN4) == GPIO_INPUT_PIN_HIGH &&
       GPIO_getInputPinValue(GPIO_PORT_P4, GPIO_PIN4) == GPIO_INPUT_PIN_HIGH)
    {
        //New Board with PUMP PWM change to P5.6 and P5.7
//        pwmConfigPumpe1.compareRegister = TIMER_A_CAPTURECOMPARE_REGISTER_1;
//        pwmConfigPumpe2.compareRegister = TIMER_A_CAPTURECOMPARE_REGISTER_2;
     //   init_Pumpe(Pumpe_Port_New);

        MAP_GPIO_setAsInputPin(GPIO_PORT_P6, GPIO_PIN6);//Set Over Current Interrupt PORT 3
        MAP_GPIO_clearInterruptFlag(GPIO_PORT_P6, GPIO_PIN6);
      //  MAP_GPIO_enableInterrupt(GPIO_PORT_P6, GPIO_PIN6);
        MAP_GPIO_interruptEdgeSelect(GPIO_PORT_P6, GPIO_PIN6,GPIO_HIGH_TO_LOW_TRANSITION);

     //   boardConfiguration=0xFF;
    }
    else
    {
        //Old Board with PUMP PWM on P6.6 and P6.7
     //   pwmConfigPumpe1.compareRegister = TIMER_A_CAPTURECOMPARE_REGISTER_3;
     //   pwmConfigPumpe2.compareRegister = TIMER_A_CAPTURECOMPARE_REGISTER_4;
     //   init_Pumpe(Pumpe_Port);

        MAP_GPIO_setAsInputPin(GPIO_PORT_P5, GPIO_PIN6);//Set Over Current Interrupt PORT 3
        MAP_GPIO_clearInterruptFlag(GPIO_PORT_P5, GPIO_PIN6);
        //MAP_GPIO_enableInterrupt(GPIO_PORT_P5, GPIO_PIN6);
        MAP_GPIO_interruptEdgeSelect(GPIO_PORT_P5, GPIO_PIN6,GPIO_HIGH_TO_LOW_TRANSITION);

      //  boardConfiguration=0x00;
    }



    //turn_Pump_OFF(Pump_1);
    //turn_Pump_OFF(Pump_2);

    //init_Ventil_PWM();
    //init_Ventil();
    //open_all_ventil();


    //UART_init();


    //Power PORT set PIN Enable
    MAP_GPIO_setAsOutputPin(GPIO_PORT_P8, GPIO_PIN4);
    MAP_GPIO_setAsOutputPin(GPIO_PORT_P8, GPIO_PIN5);
    MAP_GPIO_setAsOutputPin(GPIO_PORT_P8, GPIO_PIN6);


    MAP_GPIO_setOutputHighOnPin(GPIO_PORT_P8, GPIO_PIN4);//Power OFF
    MAP_GPIO_setOutputHighOnPin(GPIO_PORT_P8, GPIO_PIN5);//Power OFF
    MAP_GPIO_setOutputHighOnPin(GPIO_PORT_P8, GPIO_PIN6);//Power OFF


    MAP_GPIO_setAsOutputPin(GPIO_PORT_P3, GPIO_PIN2);
    MAP_GPIO_setAsOutputPin(GPIO_PORT_P2, GPIO_PIN3);

    //Power PORT set INT
    MAP_GPIO_setAsInputPin(GPIO_PORT_P5, GPIO_PIN4);//Set Over Current Interrupt PORT 1
    MAP_GPIO_setAsInputPin(GPIO_PORT_P5, GPIO_PIN5);//Set Over Current Interrupt PORT 2

    MAP_GPIO_clearInterruptFlag(GPIO_PORT_P5, GPIO_PIN4);
    MAP_GPIO_clearInterruptFlag(GPIO_PORT_P5, GPIO_PIN5);

//    MAP_GPIO_enableInterrupt(GPIO_PORT_P5, GPIO_PIN4);
//    MAP_GPIO_enableInterrupt(GPIO_PORT_P5, GPIO_PIN5);

    MAP_GPIO_interruptEdgeSelect(GPIO_PORT_P5, GPIO_PIN4,GPIO_HIGH_TO_LOW_TRANSITION);
    MAP_GPIO_interruptEdgeSelect(GPIO_PORT_P5, GPIO_PIN5,GPIO_HIGH_TO_LOW_TRANSITION);

    //MAP_Interrupt_enableInterrupt(INT_PORT5);

    //Init_I2C_GPIO_1();
    //Init_I2C_GPIO_2();
    //Init_I2C_GPIO_3();

//    I2C_init_1();
//    I2C_init_2();
//    I2C_init_3();

//    MS5525DSO_SPI_INIT();
//    set_all_CS_High();
//    MS5525DSO_Setup_Sensor(1);//init Pressure Sensor 1
//    MS5525DSO_Setup_Sensor(2);//init Pressure Sensor 2
//    MS5525DSO_Setup_Sensor(3);//init Pressure Sensor 3
//    MS5525DSO_Setup_Sensor(4);//init Pressure Sensor 4
//    MS5525DSO_Setup_Sensor(5);//init Pressure Sensor 5
//    MS5525DSO_Setup_Sensor(6);//init Pressure Sensor 6
//    MS5525DSO_Setup_Sensor(7);//init Pressure Sensor 7


     /*Initialize TMP006 temperature sensor */
    //MLX90615_init();
    //LIS2H_Init(2, LIS2H_I2C_ADD);//Init Accelerometer

     /* Configuring GPIO2.4 as peripheral output for PWM for ADPD105 */
    MAP_GPIO_setAsPeripheralModuleFunctionOutputPin(GPIO_PORT_P2, GPIO_PIN4,GPIO_PRIMARY_MODULE_FUNCTION);
    //MAP_GPIO_setAsPeripheralModuleFunctionOutputPin(GPIO_PORT_P2, GPIO_PIN5,GPIO_PRIMARY_MODULE_FUNCTION);
    //MAP_GPIO_setAsPeripheralModuleFunctionOutputPin(GPIO_PORT_P2, GPIO_PIN6,GPIO_PRIMARY_MODULE_FUNCTION);
    //MAP_GPIO_setAsPeripheralModuleFunctionOutputPin(GPIO_PORT_P2, GPIO_PIN7,GPIO_PRIMARY_MODULE_FUNCTION);

   // EXTREMITIES = 0;
   // Flag_CIS_OHR=0;
    //Zustand=0;
    MAP_Interrupt_enableMaster();

     MAP_SysCtl_setWDTTimeoutResetType(SYSCTL_SOFT_RESET);
//     MAP_WDT_A_initWatchdogTimer(WDT_A_CLOCKSOURCE_SMCLK, WDT_A_CLOCKDIVIDER_128M);
     MAP_WDT_A_initWatchdogTimer(WDT_A_CLOCKSOURCE_SMCLK, WDT_A_CLOCKDIVIDER_8192K);
     // Setting our SysTick to wake up every 128000 clock iterations to service the dog.
    MAP_SysTick_enableModule();
//    MAP_SysTick_setPeriod(48000000);
    MAP_SysTick_setPeriod(3000000);
    MAP_SysTick_enableInterrupt();
    MAP_WDT_A_startTimer();

    /*
     * debug
     */
    MAP_GPIO_setOutputLowOnPin(GPIO_PORT_P1, GPIO_PIN0);
    MAP_GPIO_setAsOutputPin(GPIO_PORT_P1, GPIO_PIN0);

    while(1)
    {
        /*
         * run Systick 20 times before enabling bsl
         */
        if(tickCounter > SYSTICK_TIMEOUT)
        {
            MAP_WDT_A_holdTimer();
            tickCounter = 0;
            MAP_GPIO_setOutputLowOnPin(GPIO_PORT_P1, GPIO_PIN0);
            MAP_GPIO_setAsInputPin(GPIO_PORT_P1, GPIO_PIN0);

            /*
             * Fix, disable the systick
             */
            MAP_SysTick_disableInterrupt();
            MAP_SysTick_disableModule();

          //  VALUE=0;
            MAP_Interrupt_disableMaster();

            NVIC->ICER[0] = 0xFFFF;
            NVIC->ICPR[0] = 0xFFFF;
            NVIC->ICER[1] = 0xFFFF;
            NVIC->ICPR[1] = 0xFFFF;
            BSL_INVOKE(0xFC48FFFF);//BSL_CONFIG_INTERFACE_UART);<---------------This doesnt work
        }
      //
    }
}
